Introduction

SafeGuard PrivateCrypto offers a user-friendly way for encrypting data. Single and multiple files as well as entire directories can be encrypted. The directory structure is preserved after decryption. Additionally, files can be compressed after encryption.


Archives

Encryption and compression of multiple files (archives) is also supported and it is possible to add and extract single files from an archive easily.
SafeGuard PrivateCrypto 1.x cannot open archives created with SafeGuard PrivateCrypto 2.x and later versions.
SafeGuard PrivateCrypto 2.x can open archives created with SafeGuard PrivateCrypto 1.x but not modify them.
Integration in Windows Explorer allows encryption of files by right-clicking on them in Windows Explorer and entering a password.
To decrypt a file, you only have to double-click an archive and enter a password or the key used for encryption has to be available to you. If a user, who should be able to decrypt the file, does not have SafeGuard PrivateCrypto installed, self-extracting executables can be created. To decrypt these files, you have to enter the password.
With the SafeGuard PrivateCrypto User Application the user can create and administrate (adding/remove files) archives. Files can be added to archives by just dragging them into the SafeGuard Private Crypto file in the user application. Default values for encryption/decryption (e.g. default folder for encrypted files, etc.) can be set there as well (SafeGuard PrivateCrypto Options dialog).


Keys from the SafeGuard Enterprise key ring

In addition to encrypting files by entering a password, SafeGuard PrivateCrypto also offers the usage of keys from the SafeGuard Enterprise key ring for encryption. If SafeGuard Enterprise is installed on the computer, all keys from the user's key ring (keys created centrally by SafeGuard Enterprise and keys created locally on the SafeGuard Enterprise client) can be used.
Thus, SafeGuard PrivateCrypto archives can simply be exchanged between SafeGuard Enterprise users. For decrypting the archive, the key used for encryption has to be available on the computer.
A prerequisite for this procedure is that SafeGuard PrivateCrypto Version 2.30 or higher is used on both computers.
HINT:
Please note that the same key has to be available on both computers (e.g. a SafeGuard Enterprise group key). If you use a SafeGuard Enterprise key, which is not contained in the recipient's key ring, the recipient cannot decrypt the archive.
If you use locally generated SafeGuard Enterprise keys, you have to communicate the passphrase to the recipient. The recipient will be automatically prompted to enter the passphrase when opening the archive.


Logging (Password History)

It is possible to generate a log file where password, file name, date of encryption and optionally a comment is saved. This log file is encrypted using an additional password or a SafeGuard Enterprise key. As the password has to be entered additionally for each encryption procedure, it can be saved in the registry to make the process more user friendly. However, please note that this represents a security risk, since there is no possibility to save the password in a secure way!
When using a SafeGuard Enterprise key for encryption, the passwords are saved without any user interaction, if the key used is included in the user's key ring.


Encrypted E-mail attachments

Using SafeGuard PrivateCrypto you can encrypt and send files via E-mail in a single procedure (see "Encrypt & Send", page 17). After encryption and optional compression the E-mail client is launched and the file is attached automatically.


Algorithms

SafeGuard PrivateCrypto uses the "Rijndael" algorithm that is defined as the new Advanced Encryption Algorithm (AES). The Utimaco implementation uses the "Rijndael" algorithm with a key length of 256 bit to encrypt data. For compression the BZIP2 library is used. The keys for encryption operations are derived from entered passwords using the PKCS#5 password based cryptography standard.
SafeGuard PrivateCrypto is available for Windows 2000, Windows XP and Windows Vista. SafeGuard PrivateCrypto is available as freeware and can be downloaded from the SafeGuard PrivateCrypto home page (www.utimaco.com/PrivateCrypto.com) for personal use.


Installation

To install SafeGuard PrivateCrypto for PC, start the setup program by double-clicking on sgpc231.exe or sgpc231.msi (resp. sgpc231_u.exe or sgpc231_u.msi for the unlicensed version).
An installation wizard will guide you through the rest of the installation procedure.


SafeGuard PrivateCrypto User Application

To start SafeGuard PrivateCrypto, click Start > Programs > SafeGuard PrivateCrypto (resp. the folder you have selected during installation) > SafeGuard PrivateCrypto.
Besides the SafeGuard PrivateCrypto Explorer extensions SafeGuard Private Crypto offers the possibility to create and administrate archives using the Safeguard Private Crypto User Application.
There, files can be added and removed from archives and single files can be extracted from an existing archive.
Files (and directories!) can be dragged from Windows Explorer to the PrivateCrypto file list. These files are then added to the current file list.
The file list of the SafeGuard PrivateCrypto User Application shows all changes made to the encryption archive currently selected:
The file is already part of the archive and will remain unmodified.
The file will be added to the encryption archive.
The file will be removed from the encryption archive.
Please note that changes to encryption archives are only done when saving the file.
Using the Decrypt button or menu command (File > Decrypt) one or more files of the encryption archive can be selected in the list and extracted (decrypted) from the archive. The encrypted versions of the files remain within the encryption archive. If no file is selected, the Decrypt command extracts all files of the archive by default.
In case entire directories are to be encrypted, the corresponding path is displayed under Path in the list view of the SafeGuard PrivateCrypto User Application.


SafeGuard PrivateCrypto Options

In the SafeGuard PrivateCrypto Options dialog (Tools > Options) default values for encryption/ decryption and password logging operations can be defined. They apply to both, the SafeGuard PrivateCrypto User Application and Windows Explorer Extensions. If required, these can be changed in the SafeGuard PrivateCrypto - Save Encrypted and SafeGuard PrivateCrypto - Decrypt (click Options) dialogs. The default settings can only be changed within the Options dialog. The Options dialog consists of three tabs:


Encryption

Default settings after installation:
  • Default Folder: empty [same as source]
  • Create self-extracting executable: deactivated
  • Secure delete source file after encryption: deactivated
  • Compress data: activated
If these settings have been changed, they can be restored by clicking the Default button.
The settings defined here are valid for all encryption operations, performed either in the SafeGuard PrivateCrypto User Application or using the Explorer Extensions. They can be overwritten temporarily for a single encryption operation (Options in the Save Encrypted dialog).
Click OK to save the settings and close the Options dialog.


Decryption

Default settings after installation:
  • Default Folder: empty [same as source]
  • Secure delete archive after decryption of all files: deactivated
If these settings have been changed, they can be restored by clicking the Default button.
The settings defined here are valid for all decryption operations, done either in the SafeGuard PrivateCrypto User Application or using the Explorer Extensions. They can be overwritten temporarily for a single decryption operation in the Decrypt dialog.
  • Default Folder:
    Files will be decrypted into this directory by default. In the drop-down list, the same directory as the source file and the My Documents folder can be selected. Another directory can be selected clicking the [...] button.
  • Secure delete archive after decryption:
    If activated, the encrypted archive will be wiped (and thus can not be restored) after decryption of all files.
Click OK to save the settings and close the Options dialog.


Password History

It is possible to generate a log file in which password, file name, date of encryption and optionally a comment can be saved. This password history is secured with an additional password or a SafeGuard Enterprise key. This password can be saved in the registry as it has to be entered for each encryption process. However, please note that this represents a security risk as the password cannot be saved in a secure way.
Viewing the password log file is only possible using the View Password History command from the Tools menu.
Default settings after installation:
  • Enable password history: deactivated
  • Password History File: none
  • Store history file password in registry: deactivated
If these settings have been changed, they can be restored by clicking the Default button.
To store path and name, password, date of creation and comments for an archive in a separate file, the Enable password history option has to be checked. The name and the path of the history file can be specified in a second step.
For convenience reasons the password for the history file (it has to be entered anytime an archive is created and the password is to be logged in the password history) can be stored in the Windows registry. Please note that this represents a security risk!
Click OK, to save the settings and close the Options dialog.


SafeGuard PrivateCrypto Password History

Users have the possibility to log their passwords in a separate file. If the user decides to log the passwords in a file (which as such represents a security risk), there are the following possibilities for securing this file:

HINT:
Settings for logging a password history do not have any effect when using SafeGuard Enterprise keys. Thus, the user will not be prompted to enter a password, if SafeGuard Enterprise keys are used for encrypting archives.

  • A secure method is to enter a password (used for encryption) for the log file for each required logging procedure. It is more secure but not user friendly because always two passwords have to be entered; one for the archive and one for the log file.
  • Alternatively, you can use a SafeGuard Enterprise key for securing the password history. The file will be encrypted without any user interaction, if the key can be accessed in the user's personal key ring.
  • The password for the log file can also be stored in the registry. This password will be used for logging. If the user wants to view the log file, this password has to be entered again. However, there is no secure way to protect the password (and therefore the log file) in this case!
Password history has to be enabled in the Options dialog (Password History tab).
The content of the password history file can only be viewed using the View Password History command from the Tools menu in the SafeGuard PrivateCrypto User Application.
Path and name, password, date of creation and optionally a comment for the archive are displayed in a list. The Copy History to Clipboard button can be used to copy the content of the history file to the clipboard from where it can be pasted into word processors for archiving concerns.

HINT:
Please be sure to empty the clipboard after using it for copying the content of the history file!


Creating new archives

New archives within SafeGuard PrivateCrypto can be created in the following ways:
1. Select the files resp. directory in Windows Explorer.
Right-click the files or the directory and click PrivateCrypto in the SafeGuard PrivateCrypto
context menu.
The SafeGuardPrivateCrypto User Application opens.
The selected files are listed in the list view of the SafeGuard PrivateCrypto User Application.
If a directory was selected, the directory name is displayed under Path.
Click Save.
You can now enter a password or select a SafeGuard Enterprise key.
Password:
Enter a password, confirm it and click OK. The archive is created in the specified target directory:
Default settings (target directory, options, etc.) can be set in the Options dialog of the SafeGuard PrivateCrypto User Application.
Key:
You can select any key from your SafeGuard Enterprise key ring.
Please note the difference between automatically generated SafeGuard Enterprise keys (group keys etc.) and locally generated keys.
If you select an automatically generated key, any user whose key ring also includes this key can open the archive.
If you use locally generated keys, a possible recipient can open the archive by entering the passphrase of this key.
A prerequisite for both cases is that the recipient uses SafeGuard PrivateCrypto Version 2.30 or a later version.
2. Open SafeGuard PrivateCrypto.
Add files by dragging them to the file list (dragging from Windows Explorer to the file list of SafeGuard PrivateCrypto). If you drag a directory, the entire directory will be added and the directory structure will also be saved.
Enter a password or select a key, confirm it and click OK. The archive is created in the specified target directory:
Default settings (target directory, options, etc.) can be set in the Options dialog of the SafeGuard PrivateCrypto User Application.
3. Select the files resp. directory in Windows Explorer.
Right-click the files or the directory and click Encrypt in the SafeGuard PrivateCrypto context menu.
Enter a password or select a key, confirm it and click OK. The archive is created as specified under Target of Encrypted Archive:
Default settings (target directory, options, etc.) can be set in the Options dialog of the SafeGuard PrivateCrypto User Application.


Save Encrypted

To save a new archive, proceed as follows:
1. Click the Save icon in the SafeGuard PrivateCrypto User Application. The Save Encrypted dialog is displayed.
2. You can now enter a password or select a SafeGuard Enterprise key.
Password:
Enter a password, confirm it and click OK. The archive is created in the specified target directory:
Default settings (target directory, options, etc.) can be set in the Options dialog of the SafeGuard PrivateCrypto User Application.
Key:
You can select any key from your SafeGuard Enterprise key ring.
Please note the difference between automatically generated SafeGuard Enterprise keys (group keys etc.) and locally generated keys.
If you select an automatically generated key, any user whose key ring also includes this key can open the archive.
If you use locally generated keys, a possible recipient can open the archive by entering the passphrase of this key.
A prerequisite for both cases is that the recipient uses SafeGuard PrivateCrypto Version 2.30 or a later version.
3. The default target directory (specified in the Options dialog) is displayed in the Target field.
Change it, if necessary. The new target directory is only valid for this single operation.
4. The name of the first file in the file list is suggested by default as a name for the archive. The file extension .uti is added automatically.
The file name can be changed.

HINT:
Please leave the file extensions unchanged!

5. Click OK.
To save an archive, also the Save Encrypted and the Save Encrypted As commands from the File menu of the SafeGuard PrivateCrypto User Application can be used.


Opening existing archives

To open an existing archive, just double-click it in Windows Explorer. The SafeGuard PrivateCrypto User Application is launched automatically.
  • If password history logging is activated and the file is secured with a password, you will first be prompted to enter the password for the password history file. Afterwards, enter the password for the archive and the archive's content is displayed.
  • If password history logging is activated and the file is secured with a SafeGuard Enterprise key included in your key ring, the archive will be opened automatically.
To open another archive, use the Open command from the File menu of the SafeGuard PrivateCrypto User Application.
To open an existing archive, the Decrypt command from the SafeGuard PrivateCrypto context menu in Windows Explorer can be also used. In this case, the archive will be decrypted immediately. Depending on the encryption type selected (password or key from the SafeGuard Enterprise key ring) the password has to be entered or the key used has to be available.


Adding files to an archive

To add files to an existing archive, use the + button. Clicking it opens an Add Files dialog where the files to be added can be selected.
To add files and directories to an archive, you can use also the Add and the Add Directory command from the Edit menu of the SafeGuard PrivateCrypto User Application.
You can also drag files or directories from Windows Explorer to SafeGuard PrivateCrypto.
Newly added files are marked with a green + symbol in the file list. They are added to the encrypted archive after clicking the Save symbol in the SafeGuard PrivateCrypto User Application.


Removing files from an archive

To remove files from an existing archive, use the - button. Select the files to be removed in the PrivateCrypto main window and click the - button. In a first step the file is marked with a red -. It is removed after clicking the Save icon in the SafeGuard PrivateCrypto User Application.
To remove files from an archive, also the Remove command from the Edit menu of the SafeGuard PrivateCrypto User Application or the Remove key on the keyboard can be used.


Decrypting files and archives

To decrypt files and archives, proceed as follows:
1. Select the required file/files in the file list of the SafeGuard PrivateCrypto User Application.
2. Click the Decrypt icon in the toolbar.
The Decrypt dialog is displayed.
3. If required, change the target directory and/or select the Secure delete archive after decryption of all files option.
4. Click OK.
All selected files are decrypted and stored in the target directory.

HINT:
To decrypt an entire archive, you can also select in Windows Explorer and click Decrypt in the SafeGuard PrivateCrypto context menu. Only the password has to be entered. In case a SafeGuard Enterprise key was used for encryption, the archive will automatically be decrypted, if the key used is available. Individual files cannot decrypted using this method.


SafeGuard PrivateCrypto Explorer extensions

The SafeGuard PrivateCrypto Explorer extensions offer an easy way to encrypt files and directories. Additionally, they allow users to encrypt files/directories and send them directly from Windows Explorer.
Right-clicking on files/directories displays a context menu with a SafeGuard PrivateCrypto submenu containing the following commands:
  • Encrypt
    To encrypt files/directories directly in Windows Explorer.
  • PrivateCypto
    To start the SafeGuard PrivateCrypto User Application. The selected files/directories are displayed in the list view of the user application. Thus, the user can add resp. remove specific files from the selection.
  • Encrypt & Send
To encrypt files directories and to send them via an e-mail client immediately.
After successful encryption, the E-mail client is launched and the encrypted archive is attached automatically.

HINT:
SafeGuard PrivateCrypto support of sending archives via E-mail requires a properly configured
E-mail program on your system!

  • SafeGuard PrivateCrypto uses a Windows function called MAPI (Mail Application Program Interface) to communicate with your E-mail program. This standard interface allows SafeGuard PrivateCrypto and other applications to control your E-mail program (e.g. to create a message or to attach a file).
    To guarantee proper functionality your system has to meet the following requirements:
    • Your E-mail program has to be a MAPI compatible mail system.
    • Your E-mail program has to support the "Simple MAPI" interface, which is required by SafeGuard PrivateCrypto.
    • The E-mail program is configured as standard mail client (or "primary MAPI client").
  • Secure delete
    To delete files securely so they cannot be restored anymore.


Encrypting files

If you want to encrypt files using SafeGuard PrivateCrypto:
1. Select a file in Windows Explorer.
2. Right click the selected file.
A context menu with a SafeGuard PrivateCrypto entry is displayed.
3. Click Encrypt.
The SafeGuard PrivateCrypto - Save Encrypted dialog is displayed.
4. You can now enter a password or select a SafeGuard Enterprise key.
Password:
Enter a password (maximum: 32 characters or digits) in the Password field and confirm it in the Confirm field.
Key:
You can select any key from your SafeGuard Enterprise key ring.
Please note the difference between automatically generated SafeGuard Enterprise keys (group keys etc.) and locally generated keys.
If you select an automatically generated key, any user whose key ring also includes this key can open the archive.
If you use locally generated keys, a possible recipient can open the archive by entering the passphrase of this key.
A prerequisite for both cases is that the recipient uses SafeGuard PrivateCrypto Version 2.30 or a later version.
5. If you want to create a self-extracting program, activate the Create Self-Extracting Executable option.
Target
In filed Target, the default target for encrypted archives specified in the Options dialog of the SafeGuard PrivateCrypto User Application is displayed. The name of the first file in the archive is suggested as a name for the encrypted file/archive the name of file resp. The file extension .uti is added to a SafeGuard PrivateCrypto encrypted file by default. If you change the file name extension, the file may become unusable.
Using the [...] button beside the field another folder in which the encrypted source file is stored, can be specified (the new path can also be entered directly in the edit field).
If you click the Options button, SafeGuard PrivateCrypto offers the following additional options:
Secure delete source files after encryption:
If this option is activated, the source file is wiped (and thus cannot be restored). Only the encrypted version of the file remains on the system.
Compress data:
Compresses the selected file/archive. Please be aware of the fact, that compression may lead to an increased file size, if it is used with very small files or with files that have already been compressed. Creating an archive requires a considerably longer processing time if compression has been activated.
Log Password to password history:
The password is stored in the password history.

HINT:
These options are predefined in the Options dialog of the SafeGuard PrivateCrypto User Application. Changing them in this dialog overrides the default settings for this single encryption operation only.

6. Click OK.


Decrypting files

To decrypt files using SafeGuard PrivateCrypto, proceed as follows:
1. Select a file in Windows Explorer.
2. Right-click on the selected archive.
A context menu with a SafeGuard PrivateCrypto entry is displayed.
3. Click Decrypt.
The Decrypt dialog is displayed.
  • If the Archive was encrypted with a password, you will be prompted to enter it. After clicking OK the archive will be decrypted.

    • HINT:
    If a wrong password is entered, the waiting period increases after each attempt.

If you click the Options button, SafeGuard PrivateCrypto offers the following additional options:
Target
In field Target, the default target for decrypted archives specified in the Options dialog of the SafeGuard PrivateCrypto User Application is displayed. Using the [...] button beside the field, another folder in which the encrypted source file is stored can be specified (the new path can also be entered directly in the edit field).
Secure delete archive after decryption of all files
If this option is activated, the encrypted archive is wiped (and thus cannot be restored). Only the decrypted version of the file remains on the system.

HINT:
These options are predefined in the Options dialog of the SafeGuard PrivateCrypto User Application. Changing them in this dialog overrides the default settings for this single decryption operation only.

  • If the archive was encrypted with a SafeGuard Enterprise key included in your key ring, the archive will be decrypted automatically.


Creating self-extracting executables

SafeGuard PrivateCrypto offers the opportunity to create self-extracting executables. The advantage of a self-extracting executable is that they can also be decrypted from users, who do not have SafeGuard PrivateCrypto installed. For decrypting them only the password or the passphrase for a locally generated SafeGuard Enterprise key is needed.
SafeGuard PrivateCrypto can also create self-extracting programs using locally created SafeGuard Enterprise keys. These .exe files can also be decrypted on computers on which neither SafeGuard PrivateCrypto nor SafeGuard Enterprise is installed. Upon launching the program, the user is prompted to enter the passphrase of the local key. This passphrase has to be communicated to the recipient beforehand.
The passphrase is defined when creating a local key for SafeGuard Enterprise.
To create a self-extracting executable using SafeGuard PrivateCrypto:
1. Select a file in Windows Explorer.
2. Right click on the selected file.
A context menu with a SafeGuard PrivateCrypto entry is displayed.
3. Click Encrypt.
The SafeGuard PrivateCrypto - Save Encrypted dialog is displayed.
4. You can now enter a password or select a SafeGuard Enterprise key.
Password:
Enter a password (maximum: 32 characters or digits) in the Password field and confirm it in the Confirm field.
Key:
For self-extracting programs you can use a locally created SafeGuard Enterprise key. To decrypt the file, the recipient has to enter the passphrase for this key. The passphrase is defined when creating a local key for SafeGuard Enterprise.
5. Activate the Create self-extracting executable option.
Target
In field Target, the default target for encrypted archives specified in the Options dialog of the SafeGuard PrivateCrypto User Application is displayed. The name of the first file in the archive is suggested as a name for the encrypted file/archive. By default the file extension .uti is added to a SafeGuard PrivateCrypto encrypted file. If you change the file name extension, the file may become unusable.
Using the [...] button beside the edit field another folder in which the encrypted source file is stored, can be specified (the new path can also be entered directly in the edit field).
If you click the Options button, SafeGuard PrivateCrypto offers the following additional options:
Secure delete source files after encryption:
If this option is activated, the source file is wiped (and thus cannot be restored). Only the encrypted version of the file remains on the system.
Compress data:
Compresses the selected file/archive.
Please be aware of the fact, that compression may lead to an increased file size if it is used with very small files or with files that have already been compressed.
Log Password to password history:
The password is stored in the password history.
6. Click OK.


Minimum password length

SafeGuard PrivateCrypto offers the possibility to define a minimum length for passwords. Therefore the DWORD entry PasswordLengthMin under the key:
HKEY_LOCAL_MACHINE\SOFTWARE\UTIMACO\SGPC
has to be added to the Windows registry. Define a value for PasswordLengthMin that defines the minimum length for passwords (in characters).


SafeGuard PrivateCrypto Command Line Interface

The command line syntax for SafeGuard PrivateCrypto is as follows (call pcrypt from the installation directory of SafeGuard PrivateCrypto):
pcrypt [path and name of source file] [options]
Options:

-e<archive> | creates the given encryption archive. If no archive is given, the name of the first file is used (with extension changed to .uti).
-d<archive> | decrypts the given encryption archive.
-a<archive> | adds the given files to an existing archive. If the target archive does not already exist, it is created.
-x<archive> | creates a self-extracting executable
-o<directory> | output directory (only for decrypt)
-p<password> | password for encrypting/decrypting
-l<password> | password for log file
-m | send the archive after encryption
-n | hides user interface but displays error messages
-q | hides user interface and error messages
-c[+|-] | compresses data at encryption
-s[+|-] | deletes source file after encryption/decryption
-t[+|-] | overwrites existing target files
-h | displays the command line syntax
-w | wipes files. Cannot be combined with encryption and decryption.
-aes256 | use the AES-256 encryption algorithm. This only applies to new archives. Default as predefined in the SafeGuard PrivateCrypto options.
@<file> | file names starting with "@" are interpreted as control files that may contain additional file names and options. This allows passing large command line strings that normally would not be possible because of command line size restrictions.

Examples:
pcrypt utimaco.txt -e -oC:\Encrypted\Utimaco_Enc.txt -p12345678 -n
-s
The file utimaco.txt is encrypted and stored as Utimaco_Enc.txt.uti (the file extension .uti is added automatically) in the directory C:\Encrypted. The password to decrypt the file is 12345678. Since -n was specified no user interface is displayed (e.g. for entering a password). The source file located in the same directory from where pcrypt was called is deleted after encryption (-s).
Creating an archive with two files:
Pcrypt test.txt test2.txt -etest.uti -psecret
Adding a third file and a directory including files (recursively) to the above archive:
Pcrypt test3.txt c:\winnt -atest.uti -psecret
Extracting some files from an archive:
Pcrypt -dtest.uti test.txt test2.txt -psecret


SafeGuard PrivateCrypto OLE Automation Interface

SafeGuard PrivateCrypto contains an OLE automation server, that can be used for programmatically using PrivateCrypto from within all applications compatible with Windows scripting. This includes the Windows Scripting Host (supporting Visual Basic Scripting, JavaScript, Perl, ...) as well as Microsoft Office applications, Web pages and programming environments like Visual Basic, Visual C++ and many more.
The class exported is named "PrivateCrypto.Archive". For scripting compatibility, it exports an IDispatch interface with the following commands and properties.
Properties:
The properties of PrivateCrypto.Archive objects are preset as defined in the PrivateCrypto options. Changing the properties of an archive object affects only subsequent operations on this single object but does not change the global settings.
CompressData
Boolean
Compression on/off.
DecryptDeleteSource
Boolean
Securely delete (wipe) the encryption archive after extracting all files.
This is done only if all files of the archive have been extracted successfully.
Extracting a single file does not cause deletion of the entire archive, even it is the only file of the archive.
DecryptFolder
String
Target folder of decrypted archive.
EncryptDeleteSource
Boolean
Securely delete (wipe) the source files after they have successfully been added to the encryption archive.
EncryptFolder
String
Target folder for encryption archives.
EncryptAlgorithm
Integer
Encryption algorithm for the archive. Default as predefined in the SafeGuard PrivateCrypto options.
Supported values are:
2=AES-256
NoGui
Boolean
This option can be set to True, if absolutely no GUI should be shown. In that case, neither dialogs nor message boxes will be displayed.
By default this option is set to False, which results in asking for passwords if they are not already passed as command parameters and popping up message boxes with descriptive text in case of errors.
If the "NoGui" property is set to True, but a user interaction is required (e.g. entering a password), the whole current operation is cancelled and an appropriate error code is returned.
PasswordLogEnabled
Boolean
Log password in password log file in case of creation of new encryption archives.
Commands:
This is the list of commands that can be called for the PrivateCrypto.Archive object. Parameters in brackets are optional. See below for a description of the single parameters:
AddFiles archive, files, pwd, (logpwd), (comment) | Add one or more files to an encryption archive. If the archive does not exist yet, it will be created.
CreateSFX archive, files, (pwd), (logpwd), (comment) | Create a self-extracting executable, containing one or more files.
Decrypt archive, (files), (pwd) | Extract one, more or even all files from an encryption archive. The files parameter may be optional here. In that case, all files are extracted from the archive.
Encrypt archive, files, (pwd), (logpwd), (comment) | Create a new encryption archive, consisting of a single or more files. If the target file already exists, the user is asked if it should be overwritten or not.
RemoveFiles archive, files, (pwd) | Remove one or more files from an encryption archive. The files are not decrypted, they are simply removed from the archive. The password is used only for authorization purposes.
Parameters:
archive | Name of the encryption archive. This is necessary for all commands.
files | This specifies either a single file name or an array of file names. See the example below on how to specify an array of file names.
pwd | The password for the encryption archive. If a new archive is created and password logging is enabled, the password is written to the log file. This parameter may be left empty for all commands. In that case, the user is prompted for the password.
logpwd | The password for the password history file. If an entry has to be added to password log file, this password is used to access the log file. The password is not required if it is already stored in the registry.
comment | The comment for the password history entry.


Example Script

Here is a sample piece of VBScript code demonstrating the use of all supported OLE automation functions:
language = "VBScript"
'======================================================
'
' This script demonstrates the SafeGuard® PrivateCrypto OLE automation object.
' During the demo, files are created in the "c:\demo" directory.
'
'======================================================
On Error Resume Next
'
' Define the name of the directory used by this demo.
' This will automatically be created, if necessary.
'
sFolder = "c:\demo"
'
' Create the necessary files for this demo
'
Call Install(sFolder)
'
' Declare and create our object for interfacing SafeGuard® PrivateCrypto
'
Dim pc
Set pc = CreateObject ("PrivateCrypto.Archive")
'
' Set encryption options
'
pc.CompressData = True
pc.EncryptDeleteSource = False
'
' Create an encryption archive, holding all files from the "files" subdirectory
'
If Not pc.Encrypt(sFolder & "\test.uti", sFolder & "\files", "secret") then
MsgBox pc.GetErrorText
End If
'
' Create a self-extracting executable from a given
' list of files. Note that if one of the given file names
' represents a directory, all files within this directory
' are used. Further, the optional log file password parameter
' is filled out here.
'
Dim arrayCreate(2)
arrayCreate(0) = sFolder & "\files"
arrayCreate(1) = sFolder & "\test.uti"
If Not pc.CreateSFX(sFolder & "\test.exe", arrayCreate, "secret", "logpwd") then
MsgBox pc.GetErrorText
End If
'
' Decrypt all files from an archive to a given location.
' Note that the empty files array parameter (par #2) specifies
' to extract all files.
'
pc.DecryptFolder = sFolder & "\decrypt"
If Not pc.Decrypt(sFolder & "\test.uti", ,"secret") then
MsgBox pc.GetErrorText
End If
'
' Remove a list of files from an archive
'
Dim arrayRemove(2)
arrayRemove(0) = "files\test2.txt"
arrayRemove(1) = "files\test3.txt"
If Not pc.RemoveFiles(sFolder & "\test.uti", arrayRemove, "secret") then
MsgBox pc.GetErrorText
End If
'
' Add a single file to an encryption archive
'
If Not pc.AddFiles(sFolder & "\test.uti", sFolder & "\files\test2.txt", "secret") then
MsgBox pc.GetErrorText
End If
'
' Free the SafeGuard® PrivateCrypto automation object
'
Set pc = nothing
MsgBox "End of demo. Generated files can be found in folder " & sFolder & "."
'
'------------------------------------------------------
' Helper routine to set-up files used by the demo script
'------------------------------------------------------
'
Sub Install (sFolder)
On Error Resume Next
Dim fso
Dim file
'
' Create a filesystem-object
'
Set fso = CreateObject("Scripting.FileSystemObject")
'
' Create directories used by the demo
'
fso.CreateFolder sFolder
fso.CreateFolder sFolder & "\files"
'
' Delete old files from earlier runs of this demo
'
fso.DeleteFile sFolder & "\test.uti"
fso.DeleteFile sFolder & "\test.exe"
fso.DeleteFile sFolder & "\decrypt\*.*"
fso.DeleteFile sFolder & "\decrypt\files\*.*"
'
' Create input files for the demo
'
    Set file = fso.CreateTextFile(sFolder & "\files\
    test1.txt", True)
file.WriteLine("This is a demo text file.")
file.Close
fso.CopyFile sFolder & "\files\test1.txt", sFolder &
    "\files\test2.txt"
fso.CopyFile sFolder & "\files\test1.txt", sFolder &
    "\files\test3.txt"
Set fso = nothing
End Sub


End User License Agreement

TERMS AND CONDITIONS
(Status: October 15, 2007)
If you continue with the download/installation, you expressly declare your consent to the following terms and conditions:

Part 1 - General Terms

1. Subject of this Agreement

The subject of this Agreement is the program, program description, operating instructions and additional accompanying material and/or documentation provided by Utimaco according to this Agreement, including any software owned by Utimaco's licensors and licensed to Utimaco for distribution as part of the Utimaco offering (collectively, the "Software"). Utimaco Safeware AG ("Utimaco") notes that it is not possible given the current state of the art to create computer software so that it will work without any errors in all applications and hardware combinations. The subject of this Agreement is therefore only software that can generally be used in the manner set out in the program description, and the operating instructions and other documentation accompanying such software. You acknowledge and agree that reference to Utimaco's licensors relating to the Software shall not be deemed to establish any contractual relationship between you and such licensors with respect to your rights under this Agreement, and you shall look solely to Utimaco and/or its resellers and distributors to enforce any such rights under this Agreement.

2. Scope of Usage; Download / Installation of Software

2.1 Upon your acceptance of these Terms and Conditions and subject to payment of the Licence Fee (as set forth in Section 7) , you will have a non-exclusive, non-transferable, non-assignable right to use the Software on the number of computer machines or network server indicated on order confirmations, delivery notes and / or invoices for the term of this Agreement. Any use going beyond these terms is expressly prohibited. This license does not constitute a sale of the Software or any portion or copy of it.

2.2 Upon your acceptance of these Terms and Conditions, you may download and install the Software and documentation. The Software shall be deemed accepted upon such download. If any feature or module of the Software is found not to conform with the express warranties set forth herein, you shall, within the warranty period, as set forth in Section 8 hereof, notify Utimaco and provide a detailed description of such defects. Your sole remedy for correction of problems after acceptance shall be pursuant to the provisions of Section 8 hereof.

3. Special Restrictions; Updates

The foregoing license rights are subject to the following restrictions:

3.1 You agree that all future modifications, enhancements, updates, revisions and/or new releases to the Software created by Utimaco (or its licensors, as applicable) shall be the sole property of Utimaco (or its licensors, as applicable).

3.2 You may make a reasonable number of copies of the Software, solely for archival and back-up purposes, provided that all of Utimaco's (or its licensors') copyright notices or other proprietary or restrictive legends or notices are reproduced on all such copies.

3.3 You shall retain the Software in strict confidence and not disclose to any third party (except as authorized by this Agreement), without Utimaco's express written consent. Utimaco hereby consents to the disclosure of the Software to your employees and contractors provided that such employee or contractor has a need to know such proprietary information.

3.4 Except for the license rights expressly and unambiguously set forth herein, you acknowledge that Utimaco or, as applicable, its licensors, retain all right, title and interest in and to the original, and any copies, of the Software and documentation, whether in machine-readable or printed form (and including, without limitation, derivative works, compilations, or collective works thereof and all related technical know-how and all rights therein), and that ownership of all patent, copyright, trademark, tradename, trade secret, technology, ideas, know-how, and other intellectual property rights pertaining thereto, shall be and remain the sole property of Utimaco or, as applicable, its licensors. You shall not be an owner of any copies of, or have any interest in, the Software, but rather, such Software is licensed pursuant to this Agreement to install and use such copies. Except for the rights expressly and unambiguously granted hereunder, Utimaco reserves for itself and its licensors all other rights in and to the Software and documentation. You shall not take any action to jeopardize, limit or interfere in any manner with Utimaco's or, as applicable, its licensors', ownership of or rights with respect to the Software and documentation.

3.5 You shall be responsible for (i) the selection, efficiency and suitability of the Software for your business purposes; (ii) the use of the Software in accordance with the documentation furnished by Utimaco; (iii) any claim of infringement based upon your combination of the Software with data or other software or devices not furnished or approved in writing by Utimaco; or (iv) the installation of the Software.

3.6 Except as expressly provided herein or to the extent permitted under applicable law, you shall not, (i) directly or indirectly, copy, modify, translate, reverse compile, disassemble, reverse engineer or otherwise determine or attempt to determine the source code of the Software or to create any derivative works based on the Software or documentation, (ii) create any modifications, enhancements, updates, revisions and / or new releases of the Software.

3.7 You shall promptly notify Utimaco in writing of any actual or suspected breach of any material obligation under this Agreement which comes to your attention, and shall cooperate with Utimaco in any legal action to prevent or stop unauthorized use, reproduction or distribution of Software or documentation.

4. Transfer of Usage Rights

You shall have no right to sell, sublicense, convey, transfer, assign, make available for time-sharing or service bureau purposes or otherwise dispose of its rights or obligations hereunder, by operation of law or otherwise to any third party, without the prior written consent of Utimaco.

5. Reproduction of Copyright Notice

The Software and the accompanying written materials are protected by copyright. A copyright note contained in the Software and a registration number contained therein may not be removed.

6. Term of this Agreement

This Agreement shall have an indefinite term unless terminated earlier as provided herein. Either party may terminate this Agreement by written notice if the other party (i) commits a material or persistent breach of this Agreement, which breach, if capable of being cured, is not cured within thirty (30) days of a written notice of termination, or (ii) becomes insolvent, makes a general assignment for the benefit of creditors, files a voluntary petition of bankruptcy, suffers or permits the appointment of a receiver for its business or assets, or becomes subject to any proceedings under any bankruptcy or insolvency law, whether domestic or foreign, or has wound up or liquidated, voluntarily or otherwise. In the event your license is terminated (i) you shall erase or return to Utimaco the Software, including all copies of the Software including any portions that have been changed and the documentation (ii) and all rights granted for you under this Agreement will cease automatically. All disclaimers, limitations of liability, indemnities and other restrictions contained in this Agreement shall survive any termination of the license granted herein.

7. License Fees

7.1 In consideration of the rights and licenses granted to Software hereunder You shall pay to Utimaco upon delivery / installation of Software license fees as separately agreed between the parties in writing (the "License Fees") as well as applicable local, state or federal taxes.

7.2 The License Fees as well as applicable taxes shall be invoiced by Utimaco to You and paid by You in accordance with the invoice by money transfer to Utimaco`s bank account with the payment term of thirty (30) days net. The interest of delay of due payment under this Agreement shall be fixed at ten percent (10%) per annum.

8. Limited Warranty

8.1 Utimaco warrants only to you that the Software, if properly installed and used by you, will function substantially in accordance with material specifications in the technical and user documentation in effect at the time of download to you; provided however, that Utimaco does not warrant that the operation of the Software will be, or that the documentation is or will be, error or bug free or uninterrupted, and Utimaco disclaims any and all liability on account thereof. Utimaco shall have no liability for any claim under this Section 8 not received by Utimaco within sixty (60) days after you download the Software.

Utimaco's sole and exclusive liability, and your sole and exclusive remedy, shall be, at Utimaco's sole election, to provide program services to attempt, through reasonable efforts, to either repair or replace such nonconforming element; provided however, that if repair or replacement is impracticable and you have been damaged by such nonconformance, then Utimaco shall refund the fees paid by you which are allocable to such nonconforming element.

The above remedies are available only if Utimaco is promptly notified in writing, within the warranty period, upon discovery of the nonconformities by you and Utimaco's examination of the Software discloses that such nonconformities exist.

Utimaco shall have no obligation under the foregoing warranty for any nonconformance caused by: (i) the incorporation, attachment or engagement of any attachment, feature, program or device, other than by Utimaco, to the Software or any part thereof; (ii) accident, transportation, neglect or misuse; (iii) alteration, modification, or enhancement of the Software other than by Utimaco; (iv) use of the Software for other than the intended purpose; (v) use of the Software on any systems other than the specified hardware platform for such Software; (vi) your use of defective media or defective duplication of the Software; or (vii) your failure to incorporate any Update previously furnished by Utimaco which corrects such nonconformance. ANY REFUND OF FEES SHALL BE DEEMED A TERMINATION OF THIS AGREEMENT (AND ANY RELATED MAINTENANCE AGREEMENT) AND SHALL BE YOUR SOLE AND EXCLUSIVE REMEDY FOR BREACH OF THE FOREGOING WARRANTY OR REJECTION OF THE SOFTWARE, AND NEITHER PARTY SHALL HAVE ANY FUTURE OBLIGATIONS OR LIABILITY HEREUNDER WITH RESPECT TO SUCH SOFTWARE.

8.2 EXCEPT FOR THE EXPRESS LIMITED WARRANTIES SET FORTH IN THIS SECTION 8, NEITHER UTIMACO NOR ANY OF ITS DISTRIBUTORS OR RESELLERS MAKE ANY WARRANTIES EXPRESS, IMPLIED (EITHER IN FACT OR BY OPERATION OF LAW), STATUTORY OR IN ANY COMMUNICATION WITH YOU WITH RESPECT TO THE SOFTWARE, OR ANY SERVICES PROVIDED IN CONNECTION THEREWITH, AND UTIMACO EXPRESSLY DISCLAIMS ANY IMPLIED WARRANTIES OR CONDITIONS INCLUDING THOSE OF TITLE, MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.

8.3 You acknowledge that as between you and Utimaco, you are solely responsible for your relationship with third party resellers of the Software. Accordingly, you hereby waive any claim or cause of action against or through such resellers involving or in connection with Utimaco or the Software. All such claims shall be deemed excluded under Section 10.

8.4 You further acknowledge and agree that you shall be solely responsible for proper back-up of all data stored in the Software and that you shall take measures to ensure such. Utimaco assumes no liability or responsibility whatsoever if data is lost.

9. Indemnification

9.1 Provided that you have used the Software in accordance with this Agreement Utimaco agrees to defend or, at its option, to settle, any claim brought against you by a third party for infringement of any third party intellectual property rights by the Software as used within the scope of this Agreement, and to indemnify you against all damages and costs finally awarded against you under any such claim or action. You agree that Utimaco shall be released from the foregoing obligation unless you have taken all reasonable steps to mitigate any potential expenses and you provide Utimaco with (a) prompt written notice of any such claim or action, or possibility thereof; (b) sole control and authority over the defense or settlement of such claim or action; and (c) proper and full information and assistance to settle and/or defend any such claim or action. If Utimaco, in its sole discretion, believes that an injunction is likely to be filed prohibiting the use of the Software by you, Utimaco may, at its sole option and expense, either: (i) procure for you the right to use the infringing Software as provided herein, (ii) replace the infringing Software with non-infringing equivalent software; (iii) modify the infringing Software so that it is not infringing; or (iv) demand return of the Software, refund the fees paid by you to Utimaco less any reasonable sum in respect of the use of the Software up to the date of termination and terminate this Agreement. Upon exercise of option (iv) in the previous sentence, Utimaco shall have no further obligations or liability to you. Except as specified above, Utimaco will not be liable for any costs or expenses incurred without its prior written authorization.

9.2 Notwithstanding the provisions of Section 9.1 above, Utimaco assumes no liability for (i) the combination of the Software with other products not provided by Utimaco; (ii) any modifications to the Software unless such modification was made by Utimaco; (iii) use of the Software if the infringement would have been avoided if the Software had been used in accordance with the documentation; (iv) any unauthorized use of Utimaco's intellectual property; or (v) third party software incorporated in the Software.

9.3 THE FOREGOING PROVISIONS OF THIS SECTION 9 STATE THE ENTIRE LIABILITY AND OBLIGATIONS OF UTIMACO, AND YOUR EXCLUSIVE REMEDY, WITH RESPECT TO ANY ACTUAL OR ALLEGED INFRINGEMENT OF ANY PATENT, COPYRIGHT, TRADE SECRET, TRADEMARK OR OTHER INTELLECTUAL PROPERTY RIGHT BY THE SOFTWARE OR ANY PART THEREOF.

9.4 You shall indemnify, hold harmless and, at Utimaco's request, defend Utimaco from and against any and all claims, liabilities, losses, damages, expenses, and costs (including attorneys' fees and costs) relating to infringement or misappropriation of intellectual property rights other than those stipulated in Section 9.1.

10. Limitation of Liability

10.1 EXCEPT FOR CLAIMS UNDER SECTION 9 RELATING TO INTELLECTUAL PROPERTY IN NO EVENT SHALL UTIMACO'S AGGREGATE LIABILITY TO YOU AND ANY THIRD PARTY ARISING OUT OF OR IN CONNECTION WITH THIS AGREEMENT, FROM ALL CAUSES OF ACTION AND THEORIES OF LIABILITY, EXCEED THE AMOUNTS PAID BY YOU FOR THE SOFTWARE.

10.2 EXCEPT FOR MISAPPROPRIATION OF UTIMACO'S (OR ITS LICENSORS') INTELLECTUAL PROPERTY BY YOU IN NO EVENT SHALL EITHER PARTY HAVE ANY LIABILITY TO THE OTHER PARTY OR TO ANY THIRD PARTY FOR ANY SPECIAL, PUNITIVE, INDIRECT, INCIDENTAL OR CONSEQUENTIAL DAMAGES INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOST PROFITS, LOSS OF DATA OR COSTS OF PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR SERVICES, ARISING OUT OF OR IN CONNECTION WITH THIS AGREEMENT OR THE USE OR PERFORMANCE OF THE SOFTWARE, WHETHER SUCH LIABILITY ARISES FROM ANY CLAIM BASED UPON CONTRACT, WARRANTY, TORT (INCLUDING NEGLIGENCE), PRODUCT LIABILITY OR OTHERWISE, EVEN IF ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH LOSS OR DAMAGES. THESE LIMITATIONS SHALL APPLY NOTWITHSTANDING THE FAILURE OF THE ESSENTIAL PURPOSE OF ANY LIMITED REMEDY. IN NO EVENT SHALL UTIMACO BE LIABLE FOR ANY REPRESENTATION OR WARRANTY MADE TO ANY THIRD PARTY BY YOU OR FOR ANY CLAIMS DIRECTLY OR INDIRECTLY RELATED TO ANY AND ALL FUTURE MODIFICATIONS, ENHANCEMENTS, UPDATES, REVISIONS AND/OR NEW RELEASES TO THE SOFTWARE CREATED BY YOU. THE PARTIES HEREBY EXPRESSLY ACKNOWLEDGE THAT THE LICENSE FEE REFLECTS THE ALLOCATION OF RISK SET FORTH IN THIS SECTION 10.

10.3 The invalidity, in whole or part, of any of the foregoing subsections will not affect the remainder of such section or subsection or any other section or subsection of this Agreement. The consideration to be received by Utimaco hereunder does not include compensation for the cost of insuring the risks and liabilities disclaimed by Utimaco. The limitations and disclaimers of Utimaco's obligations and liabilities are intended to apply to the fullest extent permitted by law, and the invalidity of application thereof to any given circumstance shall not affect such application to any other circumstance. Such limitations and disclaimers are intended to prevail over any provision in this Agreement to the contrary.

11. General

11.1 Governing Law. This Agreement and the performance of transactions under this Agreement will be governed by the laws of the State of New York, without regard to conflict of law principles, as if this Agreement was fully performed entirely within the State of New York except 1) in Germany, all disputes relating to this Agreement and the performance of transactions will be governed by German Law and will be submitted to the exclusive jurisdiction of the German Courts in Frankfurt/Main, 2) in the United Kingdom, all disputes relating to this Agreement and the performance of transactions will be governed by English Law and will be submitted to the exclusive jurisdiction of the English Courts, 3) in countries of the European Union which are not mentioned under no 1) or 2), all disputes relating to this Agreement and the performance of transactions will be governed by German Law and will be submitted to the exclusive jurisdiction of the German Courts, 4) in Japan all disputes relating to this Agreement and the performance of transactions will be governed by Japanese Law and will be submitted to the exclusive jurisdiction of the Tokyo District Court, in the first instance, 5) in all other countries, if legally permitted all disputes relating to this Agreement and the performance of transactions will be governed by German Law and will be submitted to the exclusive jurisdiction of the German Courts in Frankfurt/Main and if not legally permitted all disputes relating to this Agreement and the performance of transactions will be governed by the laws of the country in which the Software has been acquired. The United Nations' Convention on International Sale of Goods shall not apply to this Agreement. The parties each expressly waive any right to a jury trial regarding disputes related to this Agreement.

11.2 Jurisdiction; Attorney's Fees. Any dispute arising out of this Agreement shall be adjudicated exclusively in the courts of New York City, New York, except as otherwise set forth in Section 11.1. In any action or proceeding to enforce rights under this Agreement, the prevailing party will be entitled to recover costs and reasonable attorneys' fees from the other party.

11.3 Severability. If any provision of this Agreement is held to be invalid by a court of competent jurisdiction, then the remaining provisions shall nevertheless remain in full force and effect and the parties shall replace such provisions by a valid provision as close as possible to the original provision.

11.4 No Waiver. The failure of either party to enforce at any time any of the provisions of this Agreement shall not be deemed to be a waiver of the right of either party thereafter to enforce any such provisions.

11.5 Force Majeure. Except for the obligation to make payments, nonperformance of either party shall be excused to the extent that performance is rendered impossible by strike, fire, flood, governmental acts or orders or restrictions, failure of suppliers, or any other reason where failure to perform is beyond the reasonable control and not caused by the negligence of the nonperforming party.

11.6 Export Laws. You shall comply with all then current export laws and regulations of the U.S. Government and the government of the country in which you download or install the Software, which pertain to the Software.

11.7 Basis of Bargain. Each party recognizes and agrees that the warranty disclaimers and liability and remedy limitations in this Agreement are material bargained for bases of this Agreement and that they have been taken into account and reflected in determining the consideration to be given by each party to enter into this Agreement.

11.8 Mandatory Law. Consumers have legal (statutory) rights under applicable national laws relating to the sale of consumer products. This Agreement does not affect statutory rights you may have nor those rights that cannot be excluded or limited, nor rights against the person from whom you purchased the product. You may assert any statutory rights you have at your sole discretion.

11.9 Entire Agreement. This Agreement constitutes the entire, final, complete and exclusive agreement between the parties and supersedes all previous agreements or representations, oral or written, relating to this Agreement. This Agreement may not be modified or amended except in a writing signed by a duly authorized representative of each party. You acknowledge having read the terms and conditions set forth in this Agreement, understand all terms and conditions, and agree to be bound thereby. Utimaco's electronically or other properly stored copy of this Agreement shall be deemed to be the true, complete, valid, authentic and enforceable copy of this Agreement. You agree that you shall not contest the admissibility or enforceability of Utimaco's copy of this Agreement, as amended, in a court for any proceedings arising out of this Agreement. Your acceptance and this Agreement shall be deemed to be as effective as execution of this Agreement by a written signature performed manually by you, and this Agreement shall be deemed to satisfy any writings requirements of any applicable law, notwithstanding that the Agreement is written and accepted electronically. Utimaco's records of the date on which you accept this Agreement, and the effective date of all future changes to this Agreement, shall be conclusive evidence as to the effective date.

11.10 Restricted Rights Notice to U.S. Government. The Software is developed solely at private expense and delivered as "commercial computer software" as defined in DFARS 252.227-7013 (Oct. 1988), DFARS 252.211-7015 (May 1991) or DFARS 252.227-7014 (June 1995), as a "commercial item" as defined in FAR 2.101(a), DFARS 252.227-7015 (Nov. 1995) or FAR 52.227-14 (June 1987), or as "Restricted computer software" as defined in FAR 52.227.19 (June 1987), whichever is applicable. You have only those rights provided for such Software by the applicable FAR or DFARS clause or this Agreement. Manufacturer is Utimaco Safeware AG, Hohemarkstr. 22, 61440 Oberursel, Germany, except as otherwise agreed upon set forth in the offer, order confirmation, delivery note and / or invoice.

Part 2 - Country-unique Terms

GERMANY

The following Sections of Part 1 shall be replaced in whole as follows:

Section 8 (Limited Warranty) shall be replaced by the following Section 8:

8. Material Faults (Sachmängel) and Compensation of Expenses

8.1 Utimaco warrants that subject to contractually compliant use the Software meets the program description issued by Utimaco.

Where Utimaco's services deviate only marginally from the contractually agreed nature, this shall not entitle You to claims under material faults.

Furthermore, claims because of faults shall not arise in the event of excessive or improper use, natural wear and tear, failure of components in the system environment, software faults not reproducible or otherwise demonstrable by You or in the event of damage caused by particular external influences not expected under the Agreement. This shall also apply for subsequent change or repair by You or third party, unless this does not impede the analysis and rectification of a material fault.

Claims for damages and compensation of expenses shall also be governed by Section 10.

8.2 Claims because of a material fault shall be time-barred within one year from the delivery or - if installed by Utimaco - with completion of installation. This shall be without prejudice to the statutory periods for recourse under Section 478 German Civil Code (BGB) the same shall also apply in so far as the law under Section 438 Subsection 1 No. 2 German Civil Code (BGB) (buildings and items for buildings) stipulate longer periods, in the case of intentional or grossly negligent breach of duty by Utimaco, in the case of wilful non-disclosure of a fault and also in the event of fatalities, injury and impairment of health.

Utimaco's handling of warranty claim from You shall stay the warranty period only in so far as the statutory preconditions for this have been met. The warranty period shall not commence anew.

A subsequent performance (replacement delivery or repair) can influence the time bar of the fault triggering the subsequent performance.

8.3 You shall have warranty claims only if reported faults are reproducible or otherwise demonstrable by You.

8.4 If You are entitled to warranty claims, it shall initially have only the right to subsequent performance within a reasonable period of time. The subsequent performance includes either repair or provision of replacement software at the Utimaco`s discretion. Utimaco shall pay due heed to your interests when making the choice.

8.5 If the subsequent performance fails or cannot be carried out due to other reasons, subject to the statutory preconditions You can reduce the remuneration, rescind the Agreement and/or demand damages or compensation of expenses in the scope of Section 9.

You can exercise any choice it has with respect to warranty claims within a reasonable period of time, as a rule within 14 calendar days.

8.6 Utimaco can demand additional remuneration of its efforts in so far as (a) it acts in response to a report without there actually being a fault, unless You could not determine that there was no fault without making unacceptable efforts; or (b) a reported fault is not reproducible or otherwise demonstrable by You as a fault; or (c) additional effort is incurred because You have not properly complied with your duties.

Section 9 (Legal Faults) shall be replaced by the following Section 9:

9. Legal Faults (Rechtsmängel)

9.1 Utimaco shall be only liable for breach of third-party rights by its performance in so far as the performance is used as contractually agreed and in particular in the contractually envisaged use environment.

Utimaco shall be liable for breaches of third-party rights only within the European Union and the European Economic Area and also at the location of the contractually agreed use of the performance. Section 8.1 sentence 1 shall apply correspondingly.

9.2 If a third party claims against You that a performance by Utimaco breaches your rights, You shall immediately notify Utimaco. Utimaco and where appropriate its sub-suppliers shall be entitled but not obliged to defend such claims at their expense in so far as permitted.

You are not entitled to accept claims of any third party before he has given Utimaco the opportunity to put down the claims of the third party in another manner.

9.3 If a performance by Utimaco breaches third-party rights, Utimaco shall at its own discretion and expense (a) obtain for You the right to use the performance, or (b) render the performance such that it does not breach any rights; or (c) take back the performance and reimburse the remuneration rendered by You (less a reasonable deduction for use), if Utimaco cannot provide any other remedy without unreasonable effort and expense. Your interests shall be duly taken into consideration when the choice is made.

9.4 Your claims under legal faults shall be time-barred as per Section 8.2. Claims for damages and compensation of expenses shall also be governed by Section 10. Additional efforts of Utimaco are governed by Section 8.6 mutatis mutandis.

Section 10 (Limitation of Liability) shall be replaced by the following Section 10:

10. Utimaco's General Liability

10.1 Utimaco shall always be liable to You (a) for the losses caused by it and also its statutory representatives or agents intentionally or through gross negligence, (b) under the German Product Liability Act (Produkthaftungsgesetz); or losses relating to fatalities, injuries and impairment of health for which Utimaco, its statutory representatives or agents are answerable.

10.2 Utimaco shall not be liable in the event of minor negligence unless and in so far as it has breached a material duty (cardinal duty - Kardinalpflicht).

In the case of damage to property and financial losses, this liability is limited to typical losses foreseeable under such contracts. This shall also apply for foregone profit and savings not achieved. Liability for other more remote consequential damage is hereby excluded.

The liability for an individual incident is limited to the License Fee. The time bar shall be governed by Section 8.2 mutatis mutandis. The parties can negotiate and agree greater liability against separate remuneration. This shall be without prejudice to liability as per Section 10.1.

10.3 Utimaco shall be liable for damages under a guarantee only if this has been expressly agreed in the guarantee. In the event of minor negligence, this liability shall be governed by the limitations as per Section 10.2.

10.4 In the event of data loss, Utimaco shall be liable only for that effort and expense for restoring the data that would be necessary if You carried out proper data backup. In the case of minor negligence by Utimaco, this liability shall only apply if You properly backed up data immediately before the action leading to the loss of data.

10.5 Your claims for compensation of expenses and other liability claims against Utimaco shall be governed by Sections 10.1 to 10.4 mutatis mutandis.